# Define the kmod package name here.
%define	 kmod_name network-bypass

# If kversion isn't defined on the rpmbuild line, define it here.
%{!?kversion: %define kversion 3.10.0-327.10.1.v7.%{_target_cpu}}

Name:	 %{kmod_name}-kmod
Version: 2.12.0
Release: 3%{?dist}
Group:	 System Environment/Kernel
License: GPL v2
Summary: %{kmod_name} kernel modules

BuildRequires:	redhat-rpm-config
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
ExclusiveArch:	i686 x86_64

# Sources.
Source0:  caswell_drv_bypass-gen2-%{version}.tgz
Source1:  caswell_drv_bypass-gen3-1.12.0.tgz
Source2:  caswell_drv_bypass-CAD-0205VD-0.0.1.tgz
Source10: kmodtool-%{kmod_name}

# Magic hidden here.
%define kmodtool sh %{SOURCE10}
%{expand:%(%{kmodtool} rpmtemplate %{kmod_name} %{kversion} "" 2>/dev/null)}

# Disable building of the debug package(s).
%define	debug_package %{nil}

%description
%{summary}

%prep
%setup -q -c -T -a 0
%setup -q -c -T -D -a 1
%setup -q -c -T -D -a 2
echo "override %{kmod_name} * weak-updates/%{kmod_name}" > kmod-%{kmod_name}.conf

sed -i 's,bypass\.h,bypass-gen3.h,' caswell_drv_bypass-gen3-1.12.0/driver/*
mv caswell_drv_bypass-gen3-1.12.0/driver/bypass.h caswell_drv_bypass-gen3-1.12.0/driver/bypass-gen3.h

%{__cp} -a caswell_drv_bypass-gen2-%{version}/driver _kmod_build_
%{__cp} -a caswell_drv_bypass-gen3-1.12.0/driver/* _kmod_build_
%{__cp} -a caswell_drv_bypass-CAD-0205VD-0.0.1/driver/* _kmod_build_

echo "#define X86_TARGET 1" > _kmod_build_/bypass_platform_type.h
echo "#define DEF_FS_SYS_SUPPORT 1" > _kmod_build_/bypass_filesystem.h
ln -s bypass_x86.h _kmod_build_/bypass_platform.h
ln -s bypass_x86_cmd.h _kmod_build_/bypass_command.h

echo "obj-m += network-bypass.o" > _kmod_build_/Makefile
echo "network-bypass-objs += bypass_control.o bypass_sysfile.o bypass_action.o bypass_slot.o" >> _kmod_build_/Makefile
echo "obj-m += bypass-class.o" >> _kmod_build_/Makefile
echo "bypass-class-y := class.o interface.o bypass-sysfs.o" >> _kmod_build_/Makefile
echo "obj-m += bypass-CAD-0205VD.o" >> _kmod_build_/Makefile
echo "obj-m += caswell-bpgen3.o" >> _kmod_build_/Makefile
echo "caswell-bpgen3-objs := bypass.o gen3bp_driver.o csw_gxpci.o csw_spi.o csw_main.o" >> _kmod_build_/Makefile

%build
pushd _kmod_build_
ksrc=%{_usrsrc}/kernels/%{kversion}
%{__make} -C "${ksrc}" SUBDIRS=$PWD modules
popd

%install
export INSTALL_MOD_PATH=%{buildroot}
export INSTALL_MOD_DIR=extra/%{kmod_name}
pushd _kmod_build_
ksrc=%{_usrsrc}/kernels/%{kversion}
%{__make} -C "${ksrc}" modules_install M=$PWD
popd
%{__install} -d %{buildroot}%{_sysconfdir}/depmod.d/
%{__install} kmod-%{kmod_name}.conf %{buildroot}%{_sysconfdir}/depmod.d/

# Install extras
install -D -m 755 caswell_drv_bypass-gen2-%{version}/script/addressing/addressing.sh  ${INSTALL_MOD_PATH}/usr/share/doc/kmod-%{kmod_name}/addon_addressing
cp -R caswell_drv_bypass-gen2-%{version}/script/addressing/mb_cfg ${INSTALL_MOD_PATH}/usr/share/doc/kmod-%{kmod_name}/
install -D -m 755 caswell_drv_bypass-gen2-%{version}/script/bypass_tool/bypass_tool.sh ${INSTALL_MOD_PATH}/usr/sbin/network_bypass_300

# Remove the unrequired files.
%{__rm} -f %{buildroot}/lib/modules/%{kversion}/modules.*

%clean
%{__rm} -rf %{buildroot}

%changelog
* Fri May 13 2016 ClearFoundation <developer@clearfoundation.com> 2.12.0-3.clear
- Update kmodtool to latest version

* Mon Jun 1 2015 ClearFoundation <developer@clearfoundation.com> 2.12.0-2.clear
- Update to latest drivers
- Add gen3 drivers

* Fri Jun 8 2012 ClearFoundation <developer@clearfoundation.com> 1.8.2-3.clear
- Rebuild against ClearOS kernel

* Mon Oct 24 2011 ClearFoundation <developer@clearfoundation.com> 1.8.2-1.clear
- Initial build for ClearOS6
